function lines_of_file, unit
;----------------------------
; Returns number of lines 

  point_lun,unit,0   ; rewind file

  on_ioerror,ENDOFI
  lines=0 
  while not eof(unit) do begin 
     readf,unit,xdum & lines= lines +1
  endwhile

  ENDOFI:
  point_lun, unit, 0; rewind file 
  return, lines; return no of numeric lines of file
end


PRO    read_data,file,xmess,ymess

on_ioerror, ENDE

  openr, unit, file, error=err, /get_lun

  if err ne 0 then begin 
     file=pickfile(/read,title='pickfile',filter='prof')
     openr, unit, file, /get_lun
  end

; read data

  np= lines_of_file(unit) ; number of lines of file
  ymess= fltarr(np)

  for i=0,np-1 do begin
     readf,unit,xdummy, ydummy, z ; 
     ymess(i)= z
  end
  xmess= findgen(np)  ; generate abscissa values  

START:
  free_lun, unit
  return

ENDE:
  print,'There are problems with file',file

end

pro xf_prof, file
  if n_elements(file) eq 0 then file= 'xfarbe.prof'
  read_data,file,xmess,ymess
  plot,xmess,ymess,title='xfarbe profile'
end
